#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Lime
#property indicator_color2 Red
extern string  TimeFrame = "Current time frame";
extern int     CCPeriod = 12;
extern int     ATRPeriod = 12;
extern double  ATR_Multiple = 10.0;

double bufGreen[];
double bufRed[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;


int init()
{
   
   SetIndexBuffer(0, bufGreen); SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexBuffer(1, bufRed);   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, 2);
   
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   return (0);
  }

int deinit() 
{
   return (0);
}

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { bufGreen[0] = limit+1; return(0); }
   
            if (timeFrame!=Period())
            {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,timeFrame,Time[i]);               
                      bufGreen[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",CCPeriod,ATRPeriod,ATR_Multiple,0,y);
                      bufRed[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",CCPeriod,ATRPeriod,ATR_Multiple,1,y);
               }
               return(0);
             }
   for (i = limit; i >= 0; i--)
   {
      double dCCiNormal = iCCI(NULL, 0, CCPeriod, PRICE_TYPICAL, i);
      double dCCiShift1 = iCCI(NULL, 0, CCPeriod, PRICE_TYPICAL, i + 1);

      if (dCCiNormal >= 0 && dCCiShift1 < 0)    bufGreen[i + 1] = bufRed[i + 1];         
      if (dCCiNormal <= 0 && dCCiShift1 > 0)    bufRed[i + 1]   = bufGreen[i + 1];
 
      if (dCCiNormal >= 0)
      {
         bufGreen[i] = (Low[i]+Close[i])/2 - iATR(NULL, 0, ATRPeriod,i)*ATR_Multiple;
         if (bufGreen[i] < bufGreen[i + 1] && Close[i] > bufGreen[i])  bufGreen[i] = bufGreen[i + 1];
      }
      else
      {
         if (dCCiNormal <= 0)
         {
          bufRed[i] = (High[i]+Close[i])/2 + iATR(NULL, 0, ATRPeriod,i)*ATR_Multiple;
          if (bufRed[i] > bufRed[i + 1] && Close[i] < bufRed[i])  bufRed[i] = bufRed[i + 1]; 
         }
      }
   }
   return (0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

